﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SyncchronizeRecordExpandFunctionality
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xamDataGrid1.DataContext = TreeData.GenerateTreeData();
            xamDataGrid2.DataContext = TreeData.GenerateTreeData();
        }

        private void xamDataGrid1_RecordExpanded(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs e)
        {
            int level = 0;
            DataRecord rec;
            int parentRecordIndex = 0;
            if (e.Record.ParentDataRecord != null)
            {
                level = e.Record.NestingDepth;
                rec = e.Record as DataRecord;
                while (rec.ParentDataRecord != null)
                {
                    rec = rec.ParentDataRecord;
                }
                parentRecordIndex = rec.Index;
            }

                if (level == 0)
                   xamDataGrid2.Records[e.Record.Index].IsExpanded = true;

                if(level == 2)
                    ((xamDataGrid2.Records[parentRecordIndex] as DataRecord).
                        ChildRecords[e.Record.ParentRecord.Index]).ChildRecords[e.Record.Index].IsExpanded = true;


                if (level == 4)
                    ((((xamDataGrid2.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                         .ChildRecords[e.Record.ParentRecord.Index]) as DataRecord).
                         ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = true;



                if (level == 6)
                    (((((xamDataGrid2.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                         .ChildRecords[e.Record.ParentRecord.ParentRecord.Index]) as DataRecord).
                           ChildRecords[0].ChildRecords[e.Record.ParentRecord.Index] as DataRecord).
                             ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = true;
                         

        }



        private void xamDataGrid2_RecordExpanded(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs e)
        {
            int level = 0;
            DataRecord rec;
            int parentRecordIndex = 0;
            if (e.Record.ParentDataRecord != null)
            {
                level = e.Record.NestingDepth;
                rec = e.Record as DataRecord;
                while (rec.ParentDataRecord != null)
                {
                    rec = rec.ParentDataRecord;
                }
                parentRecordIndex = rec.Index;
            }
            if (level == 0)
                xamDataGrid1.Records[e.Record.Index].IsExpanded = true;

            if (level == 2)
                ((xamDataGrid1.Records[parentRecordIndex] as DataRecord).
                    ChildRecords[e.Record.ParentRecord.Index]).ChildRecords[e.Record.Index].IsExpanded = true;


            if (level == 4)
                ((((xamDataGrid1.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                     .ChildRecords[e.Record.ParentRecord.Index]) as DataRecord).
                     ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = true;



            if (level == 6)
                (((((xamDataGrid1.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                     .ChildRecords[e.Record.ParentRecord.ParentRecord.Index]) as DataRecord).
                       ChildRecords[0].ChildRecords[e.Record.ParentRecord.Index] as DataRecord).
                         ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = true;
        }



        private void xamDataGrid2_RecordCollapsed(object sender, Infragistics.Windows.DataPresenter.Events.RecordCollapsedEventArgs e)
        {
            int level = 0;
            DataRecord rec;
            int parentRecordIndex = 0;
            if (e.Record.ParentDataRecord != null)
            {
                level = e.Record.NestingDepth;
                rec = e.Record as DataRecord;
                while (rec.ParentDataRecord != null)
                {
                    rec = rec.ParentDataRecord;
                }
                parentRecordIndex = rec.Index;
            }

            if (level == 0)
                xamDataGrid1.Records[e.Record.Index].IsExpanded = false;

            if (level == 2)
                ((xamDataGrid1.Records[parentRecordIndex] as DataRecord).
                    ChildRecords[e.Record.ParentRecord.Index]).ChildRecords[e.Record.Index].IsExpanded = false;


            if (level == 4)
                ((((xamDataGrid1.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                     .ChildRecords[e.Record.ParentRecord.Index]) as DataRecord).
                     ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = false;



            if (level == 6)
                (((((xamDataGrid1.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                     .ChildRecords[e.Record.ParentRecord.ParentRecord.Index]) as DataRecord).
                       ChildRecords[0].ChildRecords[e.Record.ParentRecord.Index] as DataRecord).
                         ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = false;
        }

       

        private void xamDataGrid1_RecordCollapsed(object sender, Infragistics.Windows.DataPresenter.Events.RecordCollapsedEventArgs e)
        {
            int level = 0;
            DataRecord rec;
            int parentRecordIndex = 0;
            if (e.Record.ParentDataRecord != null)
            {
                level = e.Record.NestingDepth;
                rec = e.Record as DataRecord;
                while (rec.ParentDataRecord != null)
                {
                    rec = rec.ParentDataRecord;
                }
                parentRecordIndex = rec.Index;
            }

            if (level == 0)
                xamDataGrid2.Records[e.Record.Index].IsExpanded = false;

            if (level == 2)
                ((xamDataGrid2.Records[parentRecordIndex] as DataRecord).
                    ChildRecords[e.Record.ParentRecord.Index]).ChildRecords[e.Record.Index].IsExpanded = false;


            if (level == 4)
                ((((xamDataGrid2.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                     .ChildRecords[e.Record.ParentRecord.Index]) as DataRecord).
                     ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = false;



            if (level == 6)
                (((((xamDataGrid2.Records[parentRecordIndex] as DataRecord).ChildRecords[0])
                     .ChildRecords[e.Record.ParentRecord.ParentRecord.Index]) as DataRecord).
                       ChildRecords[0].ChildRecords[e.Record.ParentRecord.Index] as DataRecord).
                         ChildRecords[0].ChildRecords[e.Record.Index].IsExpanded = false;
        }

        public void IterateRecords(RecordCollectionBase records)
        {
            foreach (Record rec in records)
            {
                if (rec.RecordType == RecordType.GroupByField || rec.RecordType == RecordType.GroupByFieldLayout)
                {
                    GroupByRecord groupRecord = (GroupByRecord)rec;

                    //TODO: Add logic to process the group by record

                    if (groupRecord.HasChildren)
                        IterateRecords(groupRecord.ChildRecords);
                }
                else if (rec.RecordType == RecordType.DataRecord)
                {
                    DataRecord dataRecord = (DataRecord)rec;

                    //TODO: Add logic to process the data record

                    if (dataRecord.HasChildren)
                        IterateRecords(dataRecord.ChildRecords);

                }
                else if (rec.RecordType == RecordType.ExpandableFieldRecord)
                {
                    ExpandableFieldRecord expandableRecord = (ExpandableFieldRecord)rec;

                    //TODO: Add logic to process the expandable field record

                    if (expandableRecord.HasChildren)
                        IterateRecords(expandableRecord.ChildRecords);

                }
            }
        }

        public int getParentRecordIndex(DataRecord record)
        {
            if (record != null)
            {
                return record.ParentDataRecord.Index;
            }
            else
                return 0;
        }

    }

        public class TreeData : PropertyChangedNotifier
        {
            private string id;

            public string ID
            {
                get { return id; }
                set { id = value; OnPropertyChagned("ID"); }
            }

            private string name;

            public string Name
            {
                get { return name; }
                set { name = value; OnPropertyChagned("Name"); }
            }

            private ObservableCollection<TreeData> children;

            public ObservableCollection<TreeData> Children
            {
                get { return children; }
                set { children = value; OnPropertyChagned("Children"); }
            }

            public static ObservableCollection<TreeData> GenerateTreeData()
            {
                ObservableCollection<TreeData> data = new ObservableCollection<TreeData>();

                for (int i = 0; i < 4; i++)
                {
                    TreeData n = new TreeData
                    {
                        ID = "" + i,
                        Name = "Item " + i,
                        Children = new ObservableCollection<TreeData>()
                    };

                    for (int j = 0; j < 3; j++)
                    {
                        TreeData n1 = new TreeData
                        {
                            ID = "" + i + "" + j,
                            Name = "Item " + i + " " + j,
                            Children = new ObservableCollection<TreeData>()
                        };
                        TreeData n2;
                        for (int p = 0; p < 2; p++)
                        {
                            n2 = new TreeData
                           {
                               ID = " "+ i + "" + j + "" + p,
                               Name = "Item " + i + " " + j + " " + " " + p,
                               children = new ObservableCollection<TreeData>()
                           };

                            for (int m = 0; m < 2; m++)
                            {
                                n2.children.Add(new TreeData
                                {
                                    ID = " " + i + "" + j + "" + p + "" + m,
                                    Name = "Item " + i + " " + j + " " + " " + p + " " + m,

                                });
                            } 
                            
                            n1.Children.Add(n2);
                        } 
                       


                        n.Children.Add(n1);
                    }

                    data.Add(n);
                }

                return data;
            }

        }

        public class PropertyChangedNotifier : INotifyPropertyChanged
        {
            public event PropertyChangedEventHandler PropertyChanged;

            public void OnPropertyChagned(string name)
            {
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
 
}
